
		moveq	#16-1,d6	; number of levels to fade
fadeloop1:	lea	logocols+2,a0
		lea	pal(pc),a1
		moveq	#16-1,d7	; colours -1
		bsr	FadeUp		; fade colours up the same way 
		bsr	_LVOWaitVBL
		dbf	d6,fadeloop1
		
		moveq	#16-1,d6	; number of levels to fade
fadeloop2:	lea	logocols+2,a0
		lea	whitepal(pc),a1
		moveq	#16-1,d7	; colours -1
		bsr	FadeUp		; fade colours up the same way 
		bsr	_LVOWaitVBL
		dbf	d6,fadeloop2

;--------------- wait 
Wait4LMB:	bsr	_LVOCheckLMB
		bne.s	Wait4LMB

		moveq	#16-1,d6	; number of levels to fade
fadeloop3:	lea	logocols+2,a0
		lea	blackpal(pc),a1
		moveq	#16-1,d7	; colours -1
		bsr.b	FadeDown	; fade colours up the same way 
		bsr	_LVOWaitVBL
		dbf	d6,fadeloop3
		rts


***************************************************************
*   fades whole colour scheme in copper down to a desired     *
*   level - specified in the palette given to the routine     *
***************************************************************
fadedown:	move.w	(a1),d3		; get desired colour from palette
		andi.w	#$000f,d3	; get blue
		move.w	(a1),d4
		andi.w	#$00f0,d4	; get green
		move.w	(a1),d5
		andi.w	#$0f00,d5	; get red

		move.w	(a0),d0		; get colour
		andi.w	#$000f,d0	; only blue - d0 = blue
		move.w	(a0),d1
		andi.w	#$00f0,d1	; only green - d1 = green
		move.w	(a0),d2
		andi.w	#$0f00,d2	; only red - d2 = red
		
		cmpi.w	d0,d3		; is blue at desired level ?
		beq.b	nomoreblue	; yes
		subi.w	#$0001,(a0)	; if not - subtract another level
nomoreblue:	cmpi.w	d1,d4		; is green at desired level ?
		beq.b	nomoregreen	; yes - do no more subing
		subi.w	#$0010,(a0)
nomoregreen:	cmpi.w	d2,d5		; is red at desired level
		beq.b	nomorered
		subi.w	#$0100,(a0)
nomorered:	lea	4(a0),a0	; next colour in copper
		lea	2(a1),a1	; next colour in palette
		dbf	d7,fadedown	; fade all the colours down
		rts

***************************************************************
*     Fades complete copper palette up to a desired scheme    *
***************************************************************
fadeup:		move.w	(a1),d3		; get desired colour from palette
		andi.w	#$000f,d3	; get blue
		move.w	(a1),d4
		andi.w	#$00f0,d4	; get green
		move.w	(a1),d5
		andi.w	#$0f00,d5	; get red

		move.w	(a0),d0		; get colour
		andi.w	#$000f,d0	; only blue - d0 = blue
		move.w	(a0),d1
		andi.w	#$00f0,d1	; only green - d1 = green
		move.w	(a0),d2
		andi.w	#$0f00,d2	; only red - d2 = red
		
		cmpi.w	d0,d3		; is blue at desired level ?
		beq.b	unomoreblue	; yes
		addi.w	#$0001,(a0)	; if not - subtract another level
unomoreblue:	cmpi.w	d1,d4		; is green at desired level ?
		beq.b	unomoregreen	; yes - do no more subing
		addi.w	#$0010,(a0)
unomoregreen:	cmpi.w	d2,d5		; is red at desired level
		beq.b	unomorered
		addi.w	#$0100,(a0)
unomorered:	lea	4(a0),a0	; next colour in copper
		lea	2(a1),a1	; next colour in palette
		dbf	d7,fadeup	; fade all the colours up
		rts

logocols:	dc.w	$0180,$0000	;0
		dc.w	$0182,$0000	;1
		dc.w	$0184,$0000	;2
		dc.w	$0186,$0000	;3
		dc.w	$0188,$0000	;4
		dc.w	$018a,$0000	;5
		dc.w	$018c,$0000	;6
		dc.w	$018e,$0000	;7
		dc.w	$0190,$0000	;8
		dc.w	$0192,$0000	;9
		dc.w	$0194,$0000	;10
		dc.w	$0196,$0000	;11
		dc.w	$0198,$0000	;12
		dc.w	$019a,$0000	;13
		dc.w	$019c,$0000	;14
		dc.w	$019e,$0000	;15

pal:		dc.w	$0FFF,$0000,$0444,$001C
		dc.w	$012C,$023D,$024D,$035D
		dc.w	$046E,$057E,$0555,$0666
		dc.w	$0777,$0888,$0999,$0AAA

whitepal:	dc.w	$0fff,$0fff,$0fff,$0fff
		dc.w	$0fff,$0fff,$0fff,$0fff
		dc.w	$0fff,$0fff,$0fff,$0fff
		dc.w	$0fff,$0fff,$0fff,$0fff

blackpal:	dc.w	$0000,$0000,$0000,$0000
		dc.w	$0000,$0000,$0000,$0000
		dc.w	$0000,$0000,$0000,$0000
		dc.w	$0000,$0000,$0000,$0000
